#include <stdio.h>

#define NUM_PROCS 4

//int work_tasks[] = { 5, 4, 4, 3, 3 };
//int work_tasks[] = { 7, 4, 4, 3, 2, 1 };
//int work_tasks[] = { 8, 4, 4, 3, 2, 1, 1 };
//int work_tasks[] = { 6, 3, 2, 1, 1 };
int work_tasks[] = { 10, 10, 9, 8, 3, 3, 2, 2, 1, 1, 1, 1 };
//int work_tasks[] = { 10, 10, 9, 8, 6, 3, 3, 2, 2, 2, 1, 1, 1, 1, 1 };

void main(int argc, char *argv[])
{
    int i, j, k;
    int process_weight[NUM_PROCS];
    int less_weight;
    int num_tasks = sizeof(work_tasks) / 4;
    int process_tasks[NUM_PROCS][num_tasks];

    k = -1;
    memset(&process_weight,0,sizeof(int) * NUM_PROCS);
    memset(&process_tasks,0,sizeof(int) * (num_tasks * NUM_PROCS));
    process_weight[0] = 1;
    
    for( i = 0; i < num_tasks; ++i ) {
        less_weight = 0;

        for( j = 0; j < NUM_PROCS; ++j ) {
            if( process_weight[j] < process_weight[less_weight] ) {
                less_weight = j;
            }
        }
    
        process_weight[less_weight] += work_tasks[i];
        process_tasks[less_weight][i] = work_tasks[i];
    }

    printf("-----------------------------\n");
    printf("LONGEST PROCESSING TIME FIRST\n");
    printf("-----------------------------\n");
    for( i = 0; i < NUM_PROCS; ++i ) {
        printf("%i. ",i);        
        for( j = 0; j < num_tasks; ++j ) {
            if( process_tasks[i][j] != 0 ) {
                printf("[");            
                for( k = 0; k < process_tasks[i][j]; ++k )
                    printf("O");
                printf("]");
            }
        }

        printf("\n");
        //printf("\t(%i)\n",process_weight[i]);
    }

    memset(&process_weight,0,sizeof(int) * NUM_PROCS);
    memset(&process_tasks,0,sizeof(int) * (num_tasks * NUM_PROCS));
    process_weight[0] = 1;

    for( i = (num_tasks - 1); i >= 0; --i ) {
        less_weight = 0;

        for( j = 0; j < NUM_PROCS; ++j ) {
            if( process_weight[j] < process_weight[less_weight] ) {
                less_weight = j;
            }
        }
    
        process_weight[less_weight] += work_tasks[i];
        process_tasks[less_weight][i] = work_tasks[i];
    }

    printf("------------------------------\n");
    printf("SHORTEST PROCESSING TIME FIRST\n");
    printf("------------------------------\n");
    for( i = 0; i < NUM_PROCS; ++i ) {
        printf("%i. ",i);     
        for( j = (num_tasks - 1); j >= 0; --j ) {
            if( process_tasks[i][j] != 0 ) {
                printf("[");            
                for( k = 0; k < process_tasks[i][j]; ++k )
                    printf("O");
                printf("]");
            }
        }

        printf("\n");
        //printf("\t(%i)\n",process_weight[i]);
    }

    printf("\n");
}
